org.apache.xalan.xsltc.dom

## Class CurrentNodeListIterator

- java.lang.Object
- - org.apache.xml.dtm.ref.DTMAxisIteratorBase
  - - org.apache.xalan.xsltc.dom.CurrentNodeListIterator

- All Implemented Interfaces:
    java.lang.Cloneable, DTMAxisIterator

      public final class CurrentNodeListIterator
      extends DTMAxisIteratorBase

  Iterators of this kind use a CurrentNodeListFilter to filter a subset of nodes from a source iterator. For each node from the source, the boolean method CurrentNodeListFilter.test() is called. All nodes from the source are read into an array upon calling setStartNode() (this is needed to determine the value of last, a parameter to CurrentNodeListFilter.test()). The method getLast() returns the last element after applying the filter.
  Author:
    Jacek Ambroziak, Santiago Pericas-Geertsen, Morten Jorgensen

- - ### Field Summary

    - ### Fields inherited from interface org.apache.xml.dtm.DTMAxisIterator

      `END`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `CurrentNodeListIterator(DTMAxisIterator source, boolean docOrder, CurrentNodeListFilter filter, int currentNode, AbstractTranslet translet)`
    `CurrentNodeListIterator(DTMAxisIterator source, CurrentNodeListFilter filter, int currentNode, AbstractTranslet translet)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `DTMAxisIterator` | `cloneIterator()` Returns a deep copy of this iterator.
    `DTMAxisIterator` | `forceNaturalOrder()`
    `int` | `getLast()` Returns the position of the last node within the iteration, as defined by XPath.
    `void` | `gotoMark()` Restores the current node remembered by setMark().
    `boolean` | `isReverse()`
    `int` | `next()` Get the next node in the iteration.
    `DTMAxisIterator` | `reset()` Resets the iterator to the last start node.
    `void` | `setMark()` Remembers the current node for the next call to gotoMark().
    `void` | `setRestartable(boolean isRestartable)` Set if restartable.
    `DTMAxisIterator` | `setStartNode(int node)` Set start to END should 'close' the iterator, i.e. subsequent call to next() should return END.

    - ### Methods inherited from class org.apache.xml.dtm.ref.DTMAxisIteratorBase

      `getAxis, getNodeByPosition, getPosition, getStartNode, includeSelf, isDocOrdered`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### CurrentNodeListIterator

          public CurrentNodeListIterator(DTMAxisIterator source,
                                         CurrentNodeListFilter filter,
                                         int currentNode,
                                         AbstractTranslet translet)

    - #### CurrentNodeListIterator

          public CurrentNodeListIterator(DTMAxisIterator source,
                                         boolean docOrder,
                                         CurrentNodeListFilter filter,
                                         int currentNode,
                                         AbstractTranslet translet)

  - ### Method Detail

    - #### forceNaturalOrder

          public DTMAxisIterator forceNaturalOrder()

    - #### setRestartable

          public void setRestartable(boolean isRestartable)

      Description copied from interface: `DTMAxisIterator`
      Set if restartable.
      Specified by:
        `setRestartable` in interface `DTMAxisIterator`
      Overrides:
        `setRestartable` in class `DTMAxisIteratorBase`

    - #### isReverse

          public boolean isReverse()

      Specified by:
        `isReverse` in interface `DTMAxisIterator`
      Overrides:
        `isReverse` in class `DTMAxisIteratorBase`
      Returns:
        true if this iterator has a reversed axis, else false

    - #### cloneIterator

          public DTMAxisIterator cloneIterator()

      Description copied from class: `DTMAxisIteratorBase`
      Returns a deep copy of this iterator. Cloned iterators may not be restartable. The iterator being cloned may or may not become non-restartable as a side effect of this operation.
      Specified by:
        `cloneIterator` in interface `DTMAxisIterator`
      Overrides:
        `cloneIterator` in class `DTMAxisIteratorBase`
      Returns:
        a deep copy of this iterator.

    - #### reset

          public DTMAxisIterator reset()

      Description copied from interface: `DTMAxisIterator`
      Resets the iterator to the last start node.
      Specified by:
        `reset` in interface `DTMAxisIterator`
      Overrides:
        `reset` in class `DTMAxisIteratorBase`
      Returns:
        A DTMAxisIterator which has been reset to the start node, which may or may not be the same as this iterator.

    - #### next

          public int next()

      Description copied from interface: `DTMAxisIterator`
      Get the next node in the iteration.
      Returns:
        The next node handle in the iteration, or END.

    - #### setStartNode

          public DTMAxisIterator setStartNode(int node)

      Description copied from interface: `DTMAxisIterator`
      Set start to END should 'close' the iterator, i.e. subsequent call to next() should return END.
      Parameters:
        `node` - Sets the root of the iteration.
      Returns:
        A DTMAxisIterator set to the start of the iteration.

    - #### getLast

          public int getLast()

      Description copied from class: `DTMAxisIteratorBase`
      Returns the position of the last node within the iteration, as defined by XPath. In a forward iterator, I believe this equals the number of nodes which this iterator will yield. In a reverse iterator, I believe it should return 1 (since the "last" is the first produced.) This may be an expensive operation when called the first time, since it may have to iterate through a large part of the document to produce its answer.
      Specified by:
        `getLast` in interface `DTMAxisIterator`
      Overrides:
        `getLast` in class `DTMAxisIteratorBase`
      Returns:
        The number of nodes in this iterator (forward) or 1 (reverse).

    - #### setMark

          public void setMark()

      Description copied from interface: `DTMAxisIterator`
      Remembers the current node for the next call to gotoMark().

    - #### gotoMark

          public void gotoMark()

      Description copied from interface: `DTMAxisIterator`
      Restores the current node remembered by setMark().

Copyright © 2023 Apache XML Project. All Rights Reserved.